/*-----------------------------------------------------------------------------

 2002, Jeff M Soft und Hardware GmbH, All Rights Reserved

-----------------------------------------------------------------------------*/

#include "Module.h"
#include "E:\SDK2_SE_R\SEMod_struct.h"
#include "E:\SDK2_SE_R\SEPin.h"

#include <assert.h>


#include <io.h>

#include <stdlib.h>
#include <string.h>
#include <process.h>
#include <wchar.h>


void Module::sub_process(long buffer_offset, long sampleFrames )
{ 
	float *rec    = buffer_offset + input1_buffer;
	float *play   = buffer_offset + input2_buffer;
    float *again  = buffer_offset + input3_buffer;
    float *gate   = buffer_offset + input4_buffer;
    float *reload = buffer_offset + input5_buffer;

    _from = from;
	_onto = onto;

	if(*reload > 0.2) loadarray();

	if (*rec > 0.2)
	{
		REC = true;
	} 
	else
	{
		REC = false;
	}

	if ( *again > 0.2) // STOP
	{
	 taki = 0;
	}

    if ((*play > 0.2)&&(last_take > 0)) PLAY = true; else PLAY = false;

	
    if((PLAY)&& (wasoff == true))
	{
	 if((*gate > 0.2)&&(taki <= last_take))
	 {
      wasoff = false;
	  a1 = tak_note[taki]; taki++;
      midi        = NOTE_ON  + 0    + (a1 << 8) + ( velo << 16);
      midi_off[a] = NOTE_OFF + 0    + (a1 << 8) + ( velo << 16); 
      getPin(PN_MIDI_OUT)->TransmitMIDI(SampleClock(), midi);
	 }
	}

    if((*gate <= 0.2)&&(wasoff == false))
	{
		wasoff = true;
		if(last_turn > 0)
			{
			 a = a + 1;
			 if(a >= last_turn) a = 0;
			 if (midi_off[a] > 0) getPin(PN_MIDI_OUT)->TransmitMIDI(SampleClock(), midi_off[a]);
			}
	}

    if(loop == 1)
	{
     if((onto > 0)&&(_onto <= last_take))
	 {
		 if(taki >= _onto)
	     {
		  if((from > 0)&&( _from <= last_take)) taki = _from;  else taki = 0;
		 }
	 }
	 else
	 {
	      if(taki >= last_take)
		  {
			if((from > 0)&&(_from <= last_take))taki = from; else taki = 0;
		  }
	
	 }
	}


	sampleFrames = 0;
}

// The core of a MIDI plugin
void Module::OnMidiData( unsigned long p_clock, unsigned long midi_msg, short pin_id)
{
 if(err==0)	
 {
	// system messages are for timing info etc
	// they don't have a channel, just pass them right through
	bool is_system_msg = ( midi_msg & SYSTEM_MSG ) == SYSTEM_MSG;

	if( !is_system_msg )
	{
		/*
		// The first byte of a midi message contains the status (note on/off etc) and the channel
		int chan = midi_msg & 0x0f;//channel
		int stat = midi_msg & 0xf0;//on off
		// the next two bytes depend on the type of message
		int b2 = ( midi_msg / 0x100 ) & 0xff; //
		int b3 = ( midi_msg / 0x10000 ) & 0xff;
        */

		
		if((REC == true)&&(err == 0))
		{ 
		  if((midi_msg & 0xf0) == NOTE_ON)
		  {
            b2 = ( midi_msg / 0x100 ) & 0xff; //note
		    // b3 = ( midi_msg / 0x10000 ) & 0xff; //velo
			isit =(char) b2;
            fwrite(&isit, sizeof(char),1, smidifileout);
		  }
		}
	}
	
 }
}

Module::Module(seaudioMasterCallback2 seaudioMaster, void *p_resvd1) : SEModule_base(seaudioMaster, p_resvd1)
{
}

void Module::open()
{  

 err = -1;
 err2 = -1;
 isnew = false;
tak_note = NULL;
textfile = NULL;
smidifileout  = NULL;


	last_take = 0;
    taki = 0;
	SEModule_base::open();
	// choose which function is used to process audio
	SET_PROCESS_FUNC(Module::sub_process);
}

Module::~Module()
{
	if(err == 0)
	{
	  fclose(smidifileout);
	}

    if(err2 == 0)
	{
	  fclose(textfile);
	}
}

// describe the module
bool Module::getModuleProperties (SEModuleProperties* properties)
{
	LL dish;
    BB bish;
    sprintf_s(dish.thisSEM   ,mmm, "%s\n","SNOTE_RECPLAY_CIRC_M" );


   int j;
   j  = sprintf_s( bish.buffer    ,mmmm, "%s \n"  , "2009 December in Tbingen GERMANY" );
   j += sprintf_s( bish.buffer + j,mmmm, "%s"     , "\n");
   j += sprintf_s( bish.buffer + j,mmmm, "%s"  , "           FAKE MUSIC \n" ); 
   j += sprintf_s( bish.buffer + j,mmmm, "%s"     , "\n");
   j += sprintf_s( bish.buffer + j,mmmm, "%s"  , "        by ralph.a.cronin \n" ); 
   j += sprintf_s( bish.buffer + j,mmmm, "%s"     , "\n");
   j += sprintf_s( bish.buffer + j,mmmm, "%s \n"  , " http://ralphcronin.yolasite.com/modules-sem-code.php " );
   j += sprintf_s( bish.buffer + j,mmmm, "%s \n"  , dish.thisSEM );
   j += sprintf_s( bish.buffer + j,mmmm, "%s"     , "\n");
   j += sprintf_s( bish.buffer + j,mmmm, "%s \n"  , "\n" );
   j += sprintf_s( bish.buffer + j,mmmm, "%s \n"  , " Inputs:  Input keep activity with over 2 Volts = >2" );
   j += sprintf_s( bish.buffer + j,mmmm, "%s \n"  , "              Input that want only short triggers   = ^2" );
   j += sprintf_s( bish.buffer + j,mmmm, "%s \n"  , " MIDI IN -> gets its NOTE_ON recorded to OUTFILE" );
   j += sprintf_s( bish.buffer + j,mmmm, "%s \n"  , " REC        -> recording                            (>2)" );
   j += sprintf_s( bish.buffer + j,mmmm, "%s \n"  , " PLAY      -> play recorded MIDI IN from row       (>2)" );
   j += sprintf_s( bish.buffer + j,mmmm, "%s \n"  , " RETURN  -> play again from first note           (^2)" );
   j += sprintf_s( bish.buffer + j,mmmm, "%s \n"  , " GATE      -> play next recorded in row            (^2" );
   j += sprintf_s( bish.buffer + j,mmmm, "%s \n"  , " RELOAD   -> takes the record from OUTFILE to row (^2)" );


   j += sprintf_s( bish.buffer + j,mmmm, "%s \n"  , " OUTFILE -> Name the FILE for the record" );
   j += sprintf_s( bish.buffer + j,mmmm, "%s \n"  , " loopit   -> play again and again" );

   j += sprintf_s( bish.buffer + j,mmmm, "%s \n"  , " from.. -> select first note in row" );
   j += sprintf_s( bish.buffer + j,mmmm, "%s \n"  , " ..to   -> select  last note in row ( 0 = to last)" );
   j += sprintf_s( bish.buffer + j,mmmm, "%s \n"  , " next noteoff -> note length legato triggered by gate" );

   j += sprintf_s( bish.buffer + j,mmmm, "%s \n"  , "-> 0 = without NOTE_OFF  1 = imidiatly" );
   j += sprintf_s( bish.buffer + j,mmmm, "%s \n"  , "-> 2 = with next 3 = overnext ..." );
   j += sprintf_s( bish.buffer + j,mmmm, "%s \n"  , " velocity -> play note with that volume level" );
   j += sprintf_s( bish.buffer + j,mmmm, "%s \n"  , "Outputs:" );
   j += sprintf_s( bish.buffer + j,mmmm, "%s \n"  , "plays the notes of row -> MIDI OUT" );

  
	properties->name = dish.thisSEM;	// this is the name the end-user will see
	properties->id = dish.thisSEM;
	properties->about = bish.buffer;//"by ralph a. cronin and Jeff M";
	return true;
}

// describe the pins (plugs)
bool Module::getPinProperties (long index, SEPinProperties* properties)
{
	switch( index )
	{
	case 0:
		properties->name				= "MIDI In";
		properties->direction			= DR_IN;
		properties->datatype			= DT_MIDI2;
		break;
	case 1:	
		properties->name				= "REC";
		properties->variable_address	= &input1_buffer;
		properties->direction			= DR_IN;
		properties->datatype			= DT_FSAMPLE;
		properties->default_value		= "0";
		break;
    case 2:	
		properties->name				= "PLAY";
		properties->variable_address	= &input2_buffer;
		properties->direction			= DR_IN;
		properties->datatype			= DT_FSAMPLE;
		properties->default_value		= "0";
		break;
	case 3:	
		properties->name				= "RETURN";
		properties->variable_address	= &input3_buffer;
		properties->direction			= DR_IN;
		properties->datatype			= DT_FSAMPLE;
		properties->default_value		= "0";
		break;
	case 4:	
		properties->name				= "GATE";
		properties->variable_address	= &input4_buffer;
		properties->direction			= DR_IN;
		properties->datatype			= DT_FSAMPLE;
		properties->default_value		= "0";
		break;
    case 5:	
		properties->name				= "RELOAD";
		properties->variable_address	= &input5_buffer;
		properties->direction			= DR_IN;
		properties->datatype			= DT_FSAMPLE;
		properties->default_value		= "0";
		break;
	case 6:
		properties->name                = "OUTFILE";
        properties->variable_address    = &text_input;
        properties->direction           = DR_IN;
        properties->datatype            = DT_TEXT; 
        properties->flags               = IO_FILENAME;
        properties->datatype_extra      ="snote"; // file extension
        break;
	case 7:
		properties->name				= "on D: DIAGNOSE.TXT";
		properties->variable_address	= &admin;
		properties->direction			= DR_PARAMETER;
        properties->datatype			= DT_BOOL;
		properties->default_value		= "true";
		break;
    case 8:
		properties->name				= "loopit";
		properties->variable_address	= &loop;
		properties->datatype_extra		= "range 0,1";
		properties->default_value		= "1";
		properties->direction			= DR_IN;
		properties->datatype			= DT_ENUM;
		break;
    case 9:
		properties->name				= "from..";
		properties->variable_address	= &from;
	    properties->datatype_extra		= "range 0,2000";//"range 0,100";
		properties->default_value		= "0";
		properties->direction			= DR_IN;
		properties->datatype			= DT_ENUM;
		break;
    case 10:
		properties->name				= "..to";
		properties->variable_address	= &onto;
		properties->datatype_extra		= "range 0,2000";
		properties->default_value		= "0";
		properties->direction			= DR_IN;
		properties->datatype			= DT_ENUM;
		break;
     case 11:
		properties->name				= "next noteoff";
		properties->variable_address	= &last_turn;
		properties->datatype_extra		= "range 0,20";
		properties->direction			= DR_IN;
		properties->datatype			= DT_ENUM;
		break;
     case 12:
		properties->name				= "velocity";
		properties->variable_address	= &velo;
		properties->datatype_extra		= "range 0,127";
		properties->default_value		= "100";
		properties->direction			= DR_IN;
		properties->datatype			= DT_ENUM;
		break;
	case 13:
		properties->name				= "MIDI Out";
		properties->direction			= DR_OUT;
		properties->datatype			= DT_MIDI2;
		break;
	default:
		return false; // host will ask for plugs 0,1,2,3 etc. return false to signal when done
	};

	return true;
}

void Module::diag(char * melde)
{
 err2= fopen_s(&textfile,"D:\\DIAGNOSE.TXT","a+");
 if(err2 == 0)
 {
	 fwrite(melde, sizeof(char),strlen(melde), textfile);
     fclose(textfile);
 }
}

void Module::OnPlugStateChange(SEPin *pin)
{ 
	in_stat = getPin(PN_TEXT)->getStatus(); // bei 1 wechsel
    if(in_stat == ((state_type)1))
	{
	 CallHost(seaudioMasterResolveFilename,PN_TEXT, MAX_FILENAME_LENGTH, (void *) full_path );
	 if(admin)
	 {
     sprintf_s(text,400,"%s %s\n","SNOTE_RECPLAY_M",full_path);diag(text);
	 }
	 wcscpy_s((wchar_t *)&smidi_filename,strlen(full_path),(wchar_t *)&full_path);// copy name
     loadarray();
	}// here we got new path if !
}


void Module::loadarray()
{
     if(err == 0)
	 {
		 fclose(smidifileout);
		 last_take = 0;
	 }

     err =  fopen_s(&smidifileout, smidi_filename,"r+b");
	 if(err == 0)
	 {
      
	  int filehandle = _fileno(smidifileout);
      flang = _filelength(filehandle);
	  flang = flang / sizeof(char);
      
         
	  PLAY = false;
      if(tak_note != NULL) delete [] tak_note;
      tak_note = new char [++flang]; 

      unsigned long itaki = 0;
	  while(! feof(smidifileout))
      {
                fread(&ch,sizeof(char ),1,smidifileout);        // MIDI_msg
       tak_note[itaki]= ch;
                itaki++;                                      // next two    
	  }
      last_take = --itaki;
      
	  
      fclose(smidifileout);// THAT WAS THE MIDIFILE 
	  if(admin)
	  {
       sprintf_s(text,400,"%s itaki= %d\n","SNOTE_RECPLAY_M", itaki);
	   diag(text);
	  }
     
	 }
	 REC = false;
     err =  fopen_s(&smidifileout, smidi_filename,"a+b");
}
